## opencc 1.0.4

=== CMakeLists.txt ===
#
# Open Chinese Convert
#
# Copyright 2010-2015 BYVoid <byvoid@byvoid.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

######## Project settings
cmake_minimum_required(VERSION 2.8)
set (PACKAGE_NAME opencc)
project (${PACKAGE_NAME} CXX)
include (CTest)

######## Options
option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)
option(BUILD_SHARED_LIBS "Build opencc as shared library" ON)
option(ENABLE_GTEST "Build all tests." OFF)

######## Package information
set (PACKAGE_URL https://github.com/BYVoid/Opencc)
set (PACKAGE_BUGREPORT https://github.com/BYVoid/Opencc/issues)
set (OPENCC_VERSION_MAJOR 1)
set (OPENCC_VERSION_MINOR 0)
set (OPENCC_VERSION_REVISION 4)

if (CMAKE_BUILD_TYPE MATCHES Debug)
  set (version_suffix .Debug)
endif (CMAKE_BUILD_TYPE MATCHES Debug)

set (
  OPENCC_VERSION
  ${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}${version_suffix}
)

set(CPACK_SOURCE_PACKAGE_FILE_NAME
  "${PACKAGE_NAME}-${OPENCC_VERSION_MAJOR}.${OPENCC_VERSION_MINOR}.${OPENCC_VERSION_REVISION}"
)
set(CPACK_SOURCE_IGNORE_FILES
  "/build/;/test/dict.ocd;/test/dict.txt;/test/dict.bin;/other/;/opencc.xcodeproj/;/.git/;.gitignore;~$;.pyc;${CPACK_SOURCE_IGNORE_FILES}"
)
include(CPack)

######## Windows

if (WIN32)
  set(CMAKE_SHARED_LIBRARY_PREFIX ${CMAKE_INSTALL_PREFIX})
  set(CMAKE_STATIC_LIBRARY_PREFIX ${CMAKE_INSTALL_PREFIX})
endif (WIN32)

######## Mac OS X

set(CMAKE_MACOSX_RPATH 1)

######## Directory

set (DIR_PREFIX ${CMAKE_INSTALL_PREFIX})
set (DIR_INCLUDE ${DIR_PREFIX}/include/)
set (DIR_SHARE ${DIR_PREFIX}/share/)
set (DIR_ETC ${DIR_PREFIX}/etc/)
set (LIB_SUFFIX "")
set (DIR_LIBRARY ${DIR_PREFIX}/lib${LIB_SUFFIX}/)

if (DEFINED SHARE_INSTALL_PREFIX)
  set (DIR_SHARE ${SHARE_INSTALL_PREFIX})
endif (DEFINED SHARE_INSTALL_PREFIX)

if (DEFINED INCLUDE_INSTALL_DIR)
  set (DIR_INCLUDE ${INCLUDE_INSTALL_DIR})
endif (DEFINED INCLUDE_INSTALL_DIR)

if (DEFINED SYSCONF_INSTALL_DIR)
  set (DIR_ETC ${SYSCONF_INSTALL_DIR})
endif (DEFINED SYSCONF_INSTALL_DIR)

set (DIR_SHARE_OPENCC ${DIR_SHARE}opencc/)
set (DIR_SHARE_LOCALE ${DIR_SHARE}locale/)

######## Configuration

configure_file(
  opencc.pc.in
  opencc.pc
  @ONLY
)

install(
  FILES
    ${CMAKE_BINARY_DIR}/opencc.pc
  DESTINATION
    ${DIR_LIBRARY}/pkgconfig
)

######## Compiler flags

add_definitions(
  -DPKGDATADIR="${DIR_SHARE_OPENCC}"
  -DLOCALEDIR="${DIR_SHARE_LOCALE}"
  -DVERSION="${OPENCC_VERSION}"
  -DPACKAGE_NAME="${PACKAGE_NAME}"
)

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  add_definitions(
    -std=c++11
    -Wall
  )
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")
  if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-O0 -g3)
  endif ()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  add_definitions(
    -std=c++0x
    -Wall
  )
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")
  if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions(-O0 -g3)
  endif ()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  add_definitions(
    /Wall
    /D "_CRT_SECURE_NO_WARNINGS"
  )
endif()

if (NOT BUILD_SHARED_LIBS)
  add_definitions(
    -DOpencc_BUILT_AS_STATIC
  )
endif (NOT BUILD_SHARED_LIBS)

if (ENABLE_GTEST)
  add_definitions(
    -DPROJECT_BINARY_DIR="${PROJECT_BINARY_DIR}"
    -DCMAKE_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
  )
endif()

######## Subdirectories

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(data)
add_subdirectory(test)

######## Testing

if (ENABLE_GTEST)
  add_subdirectory(deps/gtest-1.7.0)
  enable_testing()
endif()

=== Makefile ===
#
# Open Chinese Convert
#
# Copyright 2010-2015 BYVoid <byvoid@byvoid.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

PREFIX = /usr

.PHONY: build clean node test xcode-build

build:
	mkdir -p build/rel
	(cd build/rel; cmake \
	-DBUILD_DOCUMENTATION:BOOL=ON \
	-DENABLE_GTEST:BOOL=OFF \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_PREFIX=${PREFIX} \
	../..)
	make -C build/rel VERBOSE=${VERBOSE} PREFIX=${PREFIX}

package: build
	make -C build/rel package_source VERBOSE=${VERBOSE}
	make -C build/rel package_source VERBOSE=${VERBOSE} PREFIX=${PREFIX}

test:
	mkdir -p build/dbg/root
	(cd build/dbg; cmake \
	-DBUILD_DOCUMENTATION:BOOL=OFF \
	-DENABLE_GTEST:BOOL=ON \
	-DCMAKE_BUILD_TYPE=Debug \
	-DCMAKE_INSTALL_PREFIX=`pwd`/root \
	../..)
	make -C build/dbg VERBOSE=${VERBOSE}
	(cd build/dbg; ctest --verbose)
	make -C build/dbg install VERBOSE=${VERBOSE}

node:
	node-gyp configure
	node-gyp build

node-test: node
	npm test

xcode-build:
	mkdir -p xcode
	(cd xcode; cmake \
	-G "Xcode" \
	-DBUILD_DOCUMENTATION:BOOL=OFF \
	-DENABLE_GTEST:BOOL=ON \
	..; \
	xcodebuild build)

test-all: test node-test

clean:
	rm -rf build xcode

install: build
	make -C build/rel install VERBOSE=${VERBOSE} PREFIX=${PREFIX}

=== data/CMakeLists.txt ===
set(OPENCC_DICT_BIN opencc_dict)
set(DICT_MERGE_BIN python ${CMAKE_CURRENT_SOURCE_DIR}/scripts/merge.py)
set(DICT_REVERSE_BIN python ${CMAKE_CURRENT_SOURCE_DIR}/scripts/reverse.py)
set(DICT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/dictionary)
set(DICT_GENERATED_DIR ${CMAKE_CURRENT_BINARY_DIR})

set(
  DICTS_RAW
  STCharacters
  STPhrases
  TSCharacters
  TSPhrases
  TWVariants
  TWVariantsRevPhrases
  JPVariants
  HKVariants
  HKVariantsPhrases
  HKVariantsRevPhrases
)

set(
  DICTS_GENERATED
  TWPhrases
  TWPhrasesRev
  TWVariantsRev
  HKVariantsRev
)

set(DICTS ${DICTS_RAW} ${DICTS_GENERATED})

foreach(DICT ${DICTS})
  set(DICT_TARGETS ${DICT_TARGETS} ${DICT}.ocd)
endforeach(DICT)

add_custom_target(
  Dictionaries
  ALL
  DEPENDS
    ${DICT_TARGETS}
)

foreach(DICT ${DICTS_RAW})
  set(DICT_${DICT}_INPUT ${DICT_DIR}/${DICT}.txt)
endforeach(DICT)

foreach(DICT ${DICTS_GENERATED})
  set(DICT_${DICT}_INPUT ${DICT_GENERATED_DIR}/${DICT}.txt)
endforeach(DICT)

set(
  DICT_TWPhrases_GENERATING_INPUT
  ${DICT_DIR}/TWPhrasesIT.txt
  ${DICT_DIR}/TWPhrasesName.txt
  ${DICT_DIR}/TWPhrasesOther.txt
)
set(
  DICT_TWPhrases_GENERATING_COMMAND
  ${DICT_MERGE_BIN} ${DICT_TWPhrases_GENERATING_INPUT} TWPhrases.txt
)

set(
  DICT_TWVariantsRev_GENERATING_INPUT
  ${DICT_DIR}/TWVariants.txt
)
set(
  DICT_TWVariantsRev_GENERATING_COMMAND
  ${DICT_REVERSE_BIN} ${DICT_TWVariantsRev_GENERATING_INPUT} TWVariantsRev.txt
)

set(
  DICT_TWPhrasesRev_GENERATING_INPUT
  ${DICT_GENERATED_DIR}/TWPhrases.txt
)
set(
  DICT_TWPhrasesRev_GENERATING_COMMAND
  ${DICT_REVERSE_BIN} ${DICT_TWPhrasesRev_GENERATING_INPUT} TWPhrasesRev.txt
)

set(
  DICT_HKVariantsRev_GENERATING_INPUT
  ${DICT_DIR}/HKVariants.txt
)
set(
  DICT_HKVariantsRev_GENERATING_COMMAND
  ${DICT_REVERSE_BIN} ${DICT_HKVariantsRev_GENERATING_INPUT} HKVariantsRev.txt
)

foreach(DICT ${DICTS_GENERATED})
  add_custom_command(
    OUTPUT
      ${DICT}.txt
    COMMENT
      "Generating ${DICT}.txt"
    COMMAND
      ${DICT_${DICT}_GENERATING_COMMAND}
    DEPENDS
      ${DICT_${DICT}_GENERATING_INPUT}
  )
  set_directory_properties(
    PROPERTIES
      ADDITIONAL_MAKE_CLEAN_FILES
        "${DICT_GENERATED_DIR}/${DICT}.txt"
  )
endforeach(DICT)

foreach(DICT ${DICTS})
  add_custom_command(
    OUTPUT
      ${DICT}.ocd
    COMMENT
      "Building ${DICT}.ocd"
    COMMAND
      ${OPENCC_DICT_BIN}
        --input ${DICT_${DICT}_INPUT}
        --output ${DICT}.ocd
        --from text
        --to ocd
    DEPENDS
      ${OPENCC_DICT_BIN}
      ${DICT_${DICT}_INPUT}
  )

  install(
    FILES
      ${DICT_GENERATED_DIR}/${DICT}.ocd
    DESTINATION
      ${DIR_SHARE_OPENCC}
  )

  set_directory_properties(
    PROPERTIES
      ADDITIONAL_MAKE_CLEAN_FILES
        "${DICT_GENERATED_DIR}/${DICT}.ocd"
  )
endforeach(DICT)

set(CONFIG_FILES
  config/s2t.json
  config/t2s.json
  config/s2tw.json
  config/s2twp.json
  config/tw2s.json
  config/tw2sp.json
  config/t2tw.json
  config/s2hk.json
  config/hk2s.json
  config/t2hk.json
)

install(
  FILES
    ${CONFIG_FILES}
  DESTINATION
    ${DIR_SHARE_OPENCC}
)

=== src/CMakeLists.txt ===
include (GenerateExportHeader)

include_directories(../deps/darts-clone)
include_directories(../deps/rapidjson-0.11)
include_directories(../deps/tclap-1.2.1)

# Library

set(
  LIBOPENCC_HEADERS
  BinaryDict.hpp
  Common.hpp
  Config.hpp
  Conversion.hpp
  ConversionChain.hpp
  Converter.hpp
  DartsDict.hpp
  Dict.hpp
  DictEntry.hpp
  DictGroup.hpp
  Exception.hpp
  Export.hpp
  Lexicon.hpp
  MaxMatchSegmentation.hpp
  Optional.hpp
  PhraseExtract.hpp
  Segmentation.hpp
  Segments.hpp
  SerializableDict.hpp
  SimpleConverter.hpp
  TextDict.hpp
  UTF8StringSlice.hpp
  UTF8Util.hpp
  opencc.h
)

set(
  LIBOPENCC_SOURCES
  BinaryDict.cpp
  Config.cpp
  Conversion.cpp
  ConversionChain.cpp
  Converter.cpp
  DartsDict.cpp
  Dict.cpp
  DictEntry.cpp
  DictGroup.cpp
  MaxMatchSegmentation.cpp
  PhraseExtract.cpp
  SimpleConverter.cpp
  Segmentation.cpp
  TextDict.cpp
  UTF8StringSlice.cpp
  UTF8Util.cpp
)

add_library(libopencc ${LIBOPENCC_SOURCES})

GENERATE_EXPORT_HEADER(
  libopencc
  BASE_NAME OPENCC
  EXPORT_MACRO_NAME OPENCC_EXPORT
  EXPORT_FILE_NAME Opencc_Export.h
  STATIC_DEFINE Opencc_BUILT_AS_STATIC
)

set_target_properties(
  libopencc
  PROPERTIES
    LINKER_LANGUAGE
      CXX
    OUTPUT_NAME
      opencc
    VERSION
      1.0.0
    SOVERSION
      2
)

# Installation

install(
  TARGETS libopencc
  LIBRARY DESTINATION ${DIR_LIBRARY}
  ARCHIVE DESTINATION ${DIR_LIBRARY}
)

install(
  FILES ${LIBOPENCC_HEADERS}
  DESTINATION ${DIR_INCLUDE}/opencc
)

# Gtest

if (ENABLE_GTEST)
  include_directories(../deps/gtest-1.7.0/include)
  set(UNITTESTS
    BinaryDictTest.cpp
    ConfigTest.cpp
    ConversionChainTest.cpp
    ConversionTest.cpp
    DartsDictTest.cpp
    DictGroupTest.cpp
    MaxMatchSegmentationTest.cpp
    PhraseExtractTest.cpp
    SimpleConverterTest.cpp
    TextDictTest.cpp
    UTF8StringSliceTest.cpp
    UTF8UtilTest.cpp
  )
  add_executable(UnitTest ${UNITTESTS})
  target_link_libraries(UnitTest gtest gtest_main libopencc)
  add_test(UnitTest UnitTest)
endif()

# Subdir

add_subdirectory(tools)

=== debian/changelog ===
opencc (1.0.4-5) unstable; urgency=medium

  * Make ocd data files arch:any (Closes: #851733)

 -- Aron Xu <aron@debian.org>  Fri, 20 Jan 2017 15:15:35 +0800

opencc (1.0.4-4) unstable; urgency=medium

  * Tighter Breaks/Conflicts version (Closes: #847145)

 -- Aron Xu <aron@debian.org>  Mon, 19 Dec 2016 23:30:01 +0800

opencc (1.0.4-3) unstable; urgency=medium

  * Correct Breaks/Conflicts version (Closes: #846665)

 -- Aron Xu <aron@debian.org>  Sun, 04 Dec 2016 16:39:48 +0800

opencc (1.0.4-2) unstable; urgency=medium

  [ Aron Xu ]
  * Install data files to libopencc2-data, drop -dbg package
    (Closes: #836395)

  [ Boyuan Yang ]
  * Add BSD-3-clause license in d/copyright

 -- Aron Xu <aron@debian.org>  Sat, 03 Sep 2016 21:07:26 +0800

opencc (1.0.4-1) unstable; urgency=medium

  * Imported Upstream version 1.0.4
  * Update d/watch to Github URL
  * std-ver: 3.9.6 -> 3.9.8, no change
  * Update VCS-Browser URL to use HTTPS

 -- Aron Xu <aron@debian.org>  Mon, 08 Aug 2016 14:43:15 +0800

opencc (1.0.3-1) experimental; urgency=medium

  * New upstream release
  * Add myself to Uploaders
  * Drop symbols file, see README.Debian

 -- Aron Xu <aron@debian.org>  Wed, 16 Dec 2015 00:34:21 +0800

opencc (1.0.2-1) experimental; urgency=medium

  * Team upload for new upstream release.
  * SONAME transition: libopencc1 -> libopencc2
  * Add libjs-jquery, libtclap-dev, darts, rapidjson-dev to B-D.
  * Patches added/updated:
    - lib-name-match-soversion.patch: rename library to match SONAME
    - install-data-file-to-meet-need-of-multi-arch.patch: updated
    - use-system-libraries.patch: do not use embeded libraries
  * Use system version of jquery.js instead of embeded one.
  * Removed python-opencc, upstream abandoned.
  * Updated symbols file.
  * Rewrite copyright file to machine-readable format.
  * Allow parallel building.

 -- Aron Xu <aron@debian.org>  Thu, 20 Nov 2014 17:09:31 +0800

=== debian/control ===
Source: opencc
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: LI Daobing <lidaobing@debian.org>,
           Asias He <asias@debian.org>,
           YunQiang Su <wzssyqa@gmail.com>,
           Osamu Aoki <osamu@debian.org>,
           Aron Xu <aron@debian.org>
Build-Depends: cmake,
               darts,
               debhelper (>= 9),
               doxygen,
               libjs-jquery,
               libtclap-dev,
               python,
               rapidjson-dev
Standards-Version: 3.9.8
Section: libs
Homepage: https://github.com/BYVoid/OpenCC
Vcs-Git: git://anonscm.debian.org/pkg-ime/opencc.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=pkg-ime/opencc.git

Package: opencc
Section: utils
Architecture: any
Multi-Arch: foreign
Depends: libopencc2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: simplified-traditional Chinese conversion tool
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the conversion tool.

Package: libopencc2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, libopencc2-data
Breaks: libopencc2-data (<< 1.0.4-5~)
Replaces: libopencc2-data (<< 1.0.4-5~)
Description: simplified-traditional Chinese conversion library - runtime
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the shared library.

Package: libopencc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libjs-jquery, libopencc2 (= ${binary:Version}), ${misc:Depends}
Description: simplified-traditional Chinese conversion library - development
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the development support files.

Package: libopencc2-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: libopencc-dev (<< 1.0.4-5~), libopencc2 (<< 1.0.4-5~)
Replaces: libopencc-dev (<< 1.0.4-5~), libopencc2 (<< 1.0.4-5~)
Description: simplified-traditional Chinese conversion library - data files
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the data files.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
# CMake doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS to enable the
# missing (hardening) flags.
CFLAGS += $(CPPFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/ \
		-DCMAKE_BUILD_TYPE=Release \
		-DBUILD_DOCUMENTATION=ON

override_dh_auto_install:
	dh_auto_install
	ln -sf /usr/share/javascript/jquery/jquery.js debian/tmp/usr/share/opencc/doc/html/jquery.js

override_dh_auto_clean:
	dh_auto_clean
	find . -name *.pyc -delete

## opencc 1.0.5

=== debian/changelog ===
opencc (1.0.5-2) unstable; urgency=medium

  * Team upload.
  * Rebuild against gcc 8.
  * debian/control:
    + Update uploaders email address and use the @debian.org one.
    + Bump Standards-Version to 4.2.1 (no changes needed).
  * debian/rules: Avoid explicit invocation to dpkg-architecture.

 -- Boyuan Yang <byang@debian.org>  Thu, 20 Sep 2018 15:07:38 -0400

opencc (1.0.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream Release.
  * Remove libopencc2 M-A:same mark for now since ocd files exist.
    (Closes: #874227)
  * Remove LI Daobing from Uploaders list. (Closes: #841792)
    Thank you for your previous work!
  * Apply "wrap-and-sort -abst".
  * d/patches: Refresh patches.
  * d/changelog: Remove trailing spaces.
  * d/control: Use debian-input-method maillist in Maintainer field.
    Closes: #899625.
  * d/control: Use Vcs URL on Salsa platform.
  * d/control: Bump Standards-Version to 4.1.4.
  * d/control: Bump debhelper compat to v11.
  * d/rules: Use NEWS.md as upstream changelog.
  * d/rules: Use "dh_missing --fail-missing".
  * d/shlibs: Explicitly require the latest library version.

 -- Boyuan Yang <073plan@gmail.com>  Thu, 21 Jun 2018 11:18:37 +0800

=== debian/control ===
Source: opencc
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Asias He <asias@debian.org>,
 YunQiang Su <syq@debian.org>,
 Osamu Aoki <osamu@debian.org>,
 Aron Xu <aron@debian.org>,
Build-Depends:
 cmake,
 darts,
 debhelper (>= 11~),
 doxygen,
 libjs-jquery,
 libtclap-dev,
 python,
 rapidjson-dev,
Standards-Version: 4.2.1
Section: libs
Homepage: https://github.com/BYVoid/OpenCC
Vcs-Git: https://salsa.debian.org/debian/opencc.git
Vcs-Browser: https://salsa.debian.org/debian/opencc

Package: libopencc-dev
Section: libdevel
Architecture: any
Depends:
 libjs-jquery,
 libopencc2 (= ${binary:Version}),
 ${misc:Depends},
Description: simplified-traditional Chinese conversion library - development
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the development support files.

Package: libopencc2
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libopencc2-data,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks: libopencc2-data (<< 1.0.4-5~)
Replaces: libopencc2-data (<< 1.0.4-5~)
Description: simplified-traditional Chinese conversion library - runtime
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the shared library.

Package: libopencc2-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 libopencc-dev (<< 1.0.4-5~),
 libopencc2 (<< 1.0.4-5~),
Replaces:
 libopencc-dev (<< 1.0.4-5~),
 libopencc2 (<< 1.0.4-5~),
Description: simplified-traditional Chinese conversion library - data files
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the data files.

Package: opencc
Section: utils
Architecture: any
Multi-Arch: foreign
Depends:
 libopencc2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: simplified-traditional Chinese conversion tool
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the conversion tool.

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/opencc-$1\.tar\.gz/ \
  https://github.com/byvoid/opencc/tags .*/ver\.?(\d\S*)\.tar\.gz

## opencc 1.0.5+git20190530

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 set (PACKAGE_BUGREPORT https://github.com/BYVoid/Opencc/issues)
 set (OPENCC_VERSION_MAJOR 1)
 set (OPENCC_VERSION_MINOR 0)
-set (OPENCC_VERSION_REVISION 4)
+set (OPENCC_VERSION_REVISION 5)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
   set (version_suffix .Debug)
@@ -53,10 +53,10 @@
 
 ######## Windows
 
-if (WIN32)
-  set(CMAKE_SHARED_LIBRARY_PREFIX ${CMAKE_INSTALL_PREFIX})
-  set(CMAKE_STATIC_LIBRARY_PREFIX ${CMAKE_INSTALL_PREFIX})
-endif (WIN32)
+#if (WIN32)
+#  set(CMAKE_SHARED_LIBRARY_PREFIX ${CMAKE_INSTALL_PREFIX})
+#  set(CMAKE_STATIC_LIBRARY_PREFIX ${CMAKE_INSTALL_PREFIX})
+#endif (WIN32)
 
 ######## Mac OS X
 
@@ -68,7 +68,6 @@
 set (DIR_INCLUDE ${DIR_PREFIX}/include/)
 set (DIR_SHARE ${DIR_PREFIX}/share/)
 set (DIR_ETC ${DIR_PREFIX}/etc/)
-set (LIB_SUFFIX "")
 set (DIR_LIBRARY ${DIR_PREFIX}/lib${LIB_SUFFIX}/)
 
 if (DEFINED SHARE_INSTALL_PREFIX)
@@ -83,8 +82,12 @@
   set (DIR_ETC ${SYSCONF_INSTALL_DIR})
 endif (DEFINED SYSCONF_INSTALL_DIR)
 
-set (DIR_SHARE_OPENCC ${DIR_SHARE}opencc/)
-set (DIR_SHARE_LOCALE ${DIR_SHARE}locale/)
+if (DEFINED LIB_INSTALL_DIR)
+  set (DIR_LIBRARY ${LIB_INSTALL_DIR})
+endif (DEFINED LIB_INSTALL_DIR)
+
+set (DIR_SHARE_OPENCC ${DIR_SHARE}/opencc/)
+set (DIR_SHARE_LOCALE ${DIR_SHARE}/locale/)
 
 ######## Configuration
 
@@ -130,7 +133,7 @@
   endif ()
 elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
   add_definitions(
-    /Wall
+    /W4
     /D "_CRT_SECURE_NO_WARNINGS"
   )
 endif()

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -110,6 +110,8 @@
     COMMENT
       "Building ${DICT}.ocd"
     COMMAND
+      ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:libopencc>" "$<TARGET_FILE_DIR:${OPENCC_DICT_BIN}>"
+    COMMAND
       ${OPENCC_DICT_BIN}
         --input ${DICT_${DICT}_INPUT}
         --output ${DICT}.ocd

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
   Converter.hpp
   DartsDict.hpp
   Dict.hpp
+  DictConverter.hpp
   DictEntry.hpp
   DictGroup.hpp
   Exception.hpp
@@ -43,6 +44,7 @@
   Converter.cpp
   DartsDict.cpp
   Dict.cpp
+  DictConverter.cpp
   DictEntry.cpp
   DictGroup.cpp
   MaxMatchSegmentation.cpp
@@ -54,7 +56,8 @@
   UTF8Util.cpp
 )
 
-add_library(libopencc ${LIBOPENCC_SOURCES})
+add_library(libopencc ${LIBOPENCC_SOURCES} ${LIBOPENCC_HEADERS})
+source_group(libopencc FILES ${LIBOPENCC_SOURCES} ${LIBOPENCC_HEADERS})
 
 GENERATE_EXPORT_HEADER(
   libopencc

=== test/CMakeLists.txt ===
include_directories(../deps/libdarts/src)
include_directories(../src)

set(CONFIG_TEST
  config_test/config_test.json
  config_test/config_test_characters.txt
  config_test/config_test_phrases.txt
)

set(CONFIG_TEST_TARGET_DIR ${PROJECT_BINARY_DIR}/test/config_test)
make_directory(${CONFIG_TEST_TARGET_DIR})
foreach (CONFIG_TEST_FILE ${CONFIG_TEST})
  configure_file(${CONFIG_TEST_FILE} ${CONFIG_TEST_TARGET_DIR} COPYONLY)
endforeach (CONFIG_TEST_FILE)

if (ENABLE_GTEST)
  include_directories(../deps/gtest-1.7.0/include)
  set(UNITTESTS
    CommandLineConvertTest
  )
  foreach(UNITTEST ${UNITTESTS})
    add_executable(${UNITTEST} ${UNITTEST}.cpp)
    target_link_libraries(${UNITTEST} gtest gtest_main libopencc)
    add_test(${UNITTEST} ${UNITTEST})
  endforeach(UNITTEST)
endif()

=== src/tools/CMakeLists.txt ===
include_directories(..)

# Executables

## opencc
add_executable(opencc CommandLine.cpp)
target_link_libraries(opencc libopencc)

## opencc_dict
add_executable(opencc_dict DictConverter.cpp)
target_link_libraries(opencc_dict libopencc)

## opencc_phrase_extract
add_executable(opencc_phrase_extract PhraseExtract.cpp)
target_link_libraries(opencc_phrase_extract libopencc)

# Installation

install(
  TARGETS opencc opencc_dict opencc_phrase_extract
  RUNTIME DESTINATION bin
)

=== debian/changelog ===
opencc (1.0.5+git20190530-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:08:50 +0100

opencc (1.0.5+git20190530-1) unstable; urgency=medium

  * Team upload.
  * New upstream git snapshot (2019-05-30).
    - opencc::ConvertDirectory is now exported.
    - Various fixes and document updates.
  * debian/control:
    + Bump Standards-Version to 4.4.0.
    + Bump debhelper copmat to v12.
    + Add build-dependency graphviz for dot support for doxygen.
  * debian/patches: Add patch 0004 to migrate from python2 to
    python3. (Closes: #937195)

 -- Boyuan Yang <byang@debian.org>  Fri, 30 Aug 2019 14:09:03 -0400

=== debian/control ===
--- 
+++ 
@@ -9,13 +9,14 @@
 Build-Depends:
  cmake,
  darts,
- debhelper (>= 11~),
+ debhelper-compat (= 12),
  doxygen,
+ graphviz,
  libjs-jquery,
  libtclap-dev,
- python,
+ python3:any,
  rapidjson-dev,
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Section: libs
 Homepage: https://github.com/BYVoid/OpenCC
 Vcs-Git: https://salsa.debian.org/debian/opencc.git
@@ -42,8 +43,10 @@
  libopencc2-data,
  ${misc:Depends},
  ${shlibs:Depends},
-Breaks: libopencc2-data (<< 1.0.4-5~)
-Replaces: libopencc2-data (<< 1.0.4-5~)
+Breaks:
+ libopencc2-data (<< 1.0.4-5~),
+Replaces:
+ libopencc2-data (<< 1.0.4-5~),
 Description: simplified-traditional Chinese conversion library - runtime
  opencc is a library for converting character between traditional Chinese and
  simplified Chinese.

=== debian/rules ===
--- 
+++ 
@@ -1,15 +1,20 @@
 #!/usr/bin/make -f
+# -*- makefile -*-
+# Uncomment this to turn on verbose mode.
+# export DH_VERBOSE=1
+
+# see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-DPKG_EXPORT_BUILDFLAGS = 1
--include /usr/share/dpkg/buildflags.mk
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+
 # CMake doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS to enable the
 # missing (hardening) flags.
 CFLAGS += $(CPPFLAGS)
 
-DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+include /usr/share/dpkg/architecture.mk
 
 %:
-	dh $@ --buildsystem=cmake --parallel
+	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
@@ -25,3 +30,9 @@
 override_dh_auto_clean:
 	dh_auto_clean
 	find . -name *.pyc -delete
+
+override_dh_installchangelogs:
+	dh_installchangelogs -k NEWS.md
+
+override_dh_missing:
+	dh_missing --fail-missing

## opencc 1.1.1+git20200624+ds2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # Open Chinese Convert
 #
-# Copyright 2010-2015 BYVoid <byvoid@byvoid.com>
+# Copyright 2010-2020 Carbo Kuo <byvoid@byvoid.com>
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -26,13 +26,17 @@
 option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)
 option(BUILD_SHARED_LIBS "Build opencc as shared library" ON)
 option(ENABLE_GTEST "Build all tests." OFF)
+option(ENABLE_BENCHMARK "Build benchmark tests." OFF)
+option(ENABLE_DARTS "Build DartsDict (ocd format)." ON)
+option(BUILD_BUNDLED_LIBMARISA "" ON)
+option(BUILD_PYTHON "Build python library" OFF)
 
 ######## Package information
 set (PACKAGE_URL https://github.com/BYVoid/Opencc)
 set (PACKAGE_BUGREPORT https://github.com/BYVoid/Opencc/issues)
 set (OPENCC_VERSION_MAJOR 1)
-set (OPENCC_VERSION_MINOR 0)
-set (OPENCC_VERSION_REVISION 5)
+set (OPENCC_VERSION_MINOR 1)
+set (OPENCC_VERSION_REVISION 1)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
   set (version_suffix .Debug)
@@ -60,7 +64,9 @@
 
 ######## Mac OS X
 
-set(CMAKE_MACOSX_RPATH 1)
+if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+    set(CMAKE_MACOSX_RPATH 1)
+endif()
 
 ######## Directory
 
@@ -113,7 +119,7 @@
   -DPACKAGE_NAME="${PACKAGE_NAME}"
 )
 
-if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
   add_definitions(
     -std=c++11
     -Wall
@@ -151,6 +157,34 @@
   )
 endif()
 
+if (ENABLE_BENCHMARK)
+  add_definitions(
+    -DPROJECT_BINARY_DIR="${PROJECT_BINARY_DIR}"
+    -DCMAKE_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
+  )
+endif()
+
+if (ENABLE_DARTS)
+  add_definitions(
+    -DENABLE_DARTS
+  )
+endif()
+
+
+######## Dependencies
+
+if(BUILD_BUNDLED_LIBMARISA)
+  message(STATUS "Use bundled marisa library.")
+  add_subdirectory(deps/marisa-0.2.5)
+else()
+  find_library(LIBMARISA NAMES marisa)
+  if (LIBMARISA)
+    message(STATUS "libmarisa found: ${LIBMARISA}")
+  else()
+    message(FATAL_ERROR "libmarisa not found.")
+  endif()
+endif()
+
 ######## Subdirectories
 
 add_subdirectory(src)
@@ -161,6 +195,20 @@
 ######## Testing
 
 if (ENABLE_GTEST)
-  add_subdirectory(deps/gtest-1.7.0)
+  add_subdirectory(deps/gtest-1.11.0)
   enable_testing()
 endif()
+
+if (ENABLE_BENCHMARK)
+  set(BENCHMARK_ENABLE_TESTING OFF)
+  add_subdirectory(deps/google-benchmark)
+  enable_testing()
+endif()
+
+######## Python
+
+if (BUILD_PYTHON)
+  add_subdirectory(deps/pybind11-2.5.0)
+  pybind11_add_module(opencc_clib src/py_opencc.cpp)
+  target_link_libraries(opencc_clib PRIVATE libopencc)
+endif()

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,8 @@
+find_package(PythonInterp REQUIRED)
+
 set(OPENCC_DICT_BIN opencc_dict)
-set(DICT_MERGE_BIN python ${CMAKE_CURRENT_SOURCE_DIR}/scripts/merge.py)
-set(DICT_REVERSE_BIN python ${CMAKE_CURRENT_SOURCE_DIR}/scripts/reverse.py)
+set(DICT_MERGE_BIN "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/scripts/merge.py")
+set(DICT_REVERSE_BIN "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/scripts/reverse.py")
 set(DICT_DIR ${CMAKE_CURRENT_SOURCE_DIR}/dictionary)
 set(DICT_GENERATED_DIR ${CMAKE_CURRENT_BINARY_DIR})
 
@@ -12,10 +14,11 @@
   TSPhrases
   TWVariants
   TWVariantsRevPhrases
+  HKVariants
+  HKVariantsRevPhrases
   JPVariants
-  HKVariants
-  HKVariantsPhrases
-  HKVariantsRevPhrases
+  JPShinjitaiCharacters
+  JPShinjitaiPhrases
 )
 
 set(
@@ -24,12 +27,13 @@
   TWPhrasesRev
   TWVariantsRev
   HKVariantsRev
+  JPVariantsRev
 )
 
 set(DICTS ${DICTS_RAW} ${DICTS_GENERATED})
 
 foreach(DICT ${DICTS})
-  set(DICT_TARGETS ${DICT_TARGETS} ${DICT}.ocd)
+  set(DICT_TARGETS ${DICT_TARGETS} ${DICT}.ocd2)
 endforeach(DICT)
 
 add_custom_target(
@@ -85,6 +89,15 @@
   ${DICT_REVERSE_BIN} ${DICT_HKVariantsRev_GENERATING_INPUT} HKVariantsRev.txt
 )
 
+set(
+  DICT_JPVariantsRev_GENERATING_INPUT
+  ${DICT_DIR}/JPVariants.txt
+)
+set(
+  DICT_JPVariantsRev_GENERATING_COMMAND
+  ${DICT_REVERSE_BIN} ${DICT_JPVariantsRev_GENERATING_INPUT} JPVariantsRev.txt
+)
+
 foreach(DICT ${DICTS_GENERATED})
   add_custom_command(
     OUTPUT
@@ -106,17 +119,17 @@
 foreach(DICT ${DICTS})
   add_custom_command(
     OUTPUT
-      ${DICT}.ocd
+      ${DICT}.ocd2
     COMMENT
-      "Building ${DICT}.ocd"
+      "Building ${DICT}.ocd2"
     COMMAND
       ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:libopencc>" "$<TARGET_FILE_DIR:${OPENCC_DICT_BIN}>"
     COMMAND
       ${OPENCC_DICT_BIN}
         --input ${DICT_${DICT}_INPUT}
-        --output ${DICT}.ocd
+        --output ${DICT}.ocd2
         --from text
-        --to ocd
+        --to ocd2
     DEPENDS
       ${OPENCC_DICT_BIN}
       ${DICT_${DICT}_INPUT}
@@ -124,7 +137,7 @@
 
   install(
     FILES
-      ${DICT_GENERATED_DIR}/${DICT}.ocd
+      ${DICT_GENERATED_DIR}/${DICT}.ocd2
     DESTINATION
       ${DIR_SHARE_OPENCC}
   )
@@ -132,21 +145,25 @@
   set_directory_properties(
     PROPERTIES
       ADDITIONAL_MAKE_CLEAN_FILES
-        "${DICT_GENERATED_DIR}/${DICT}.ocd"
+        "${DICT_GENERATED_DIR}/${DICT}.ocd2"
   )
 endforeach(DICT)
 
 set(CONFIG_FILES
+  config/hk2s.json
+  config/hk2t.json
+  config/jp2t.json
+  config/s2hk.json
   config/s2t.json
-  config/t2s.json
   config/s2tw.json
   config/s2twp.json
+  config/t2hk.json
+  config/t2jp.json
+  config/t2s.json
+  config/t2tw.json
   config/tw2s.json
   config/tw2sp.json
-  config/t2tw.json
-  config/s2hk.json
-  config/hk2s.json
-  config/t2hk.json
+  config/tw2t.json
 )
 
 install(

=== src/CMakeLists.txt ===
include (GenerateExportHeader)
include_directories(../deps/marisa-0.2.5/include)
include_directories(../deps/rapidjson-1.1.0)
include_directories(../deps/tclap-1.2.2)

# Library

set(
  LIBOPENCC_HEADERS
  Common.hpp
  Config.hpp
  Conversion.hpp
  ConversionChain.hpp
  Converter.hpp
  Dict.hpp
  DictConverter.hpp
  DictEntry.hpp
  DictGroup.hpp
  Exception.hpp
  Export.hpp
  Lexicon.hpp
  MarisaDict.hpp
  MaxMatchSegmentation.hpp
  Optional.hpp
  PhraseExtract.hpp
  Segmentation.hpp
  Segments.hpp
  SerializableDict.hpp
  SerializedValues.hpp
  SimpleConverter.hpp
  TextDict.hpp
  UTF8StringSlice.hpp
  UTF8Util.hpp
  opencc.h
)

set(
  LIBOPENCC_SOURCES
  Config.cpp
  Conversion.cpp
  ConversionChain.cpp
  Converter.cpp
  Dict.cpp
  DictConverter.cpp
  DictEntry.cpp
  DictGroup.cpp
  Lexicon.cpp
  MarisaDict.cpp
  MaxMatchSegmentation.cpp
  PhraseExtract.cpp
  SerializedValues.cpp
  SimpleConverter.cpp
  Segmentation.cpp
  TextDict.cpp
  UTF8StringSlice.cpp
  UTF8Util.cpp
)

set(UNITTESTS
  ConfigTest
  ConversionChainTest
  ConversionTest
  DictGroupTest
  MarisaDictTest
  MaxMatchSegmentationTest
  PhraseExtractTest
  SerializedValuesTest
  SimpleConverterTest
  TextDictTest
  UTF8StringSliceTest
  UTF8UtilTest
)

if (ENABLE_DARTS)
  include_directories(../deps/darts-clone)
  set(
    LIBOPENCC_HEADERS
    ${LIBOPENCC_HEADERS}
    BinaryDict.hpp
    DartsDict.hpp
  )
  set(
    LIBOPENCC_SOURCES
    ${LIBOPENCC_SOURCES}
    BinaryDict.cpp
    DartsDict.cpp
  )
  set(
    UNITTESTS
    ${UNITTESTS}
    BinaryDictTest
    DartsDictTest
  )
endif()

add_library(libopencc ${LIBOPENCC_SOURCES} ${LIBOPENCC_HEADERS})
set_target_properties(libopencc PROPERTIES POSITION_INDEPENDENT_CODE ON)
source_group(libopencc FILES ${LIBOPENCC_SOURCES} ${LIBOPENCC_HEADERS})
target_link_libraries(libopencc marisa)

GENERATE_EXPORT_HEADER(
  libopencc
  BASE_NAME OPENCC
  EXPORT_MACRO_NAME OPENCC_EXPORT
  EXPORT_FILE_NAME Opencc_Export.h
  STATIC_DEFINE Opencc_BUILT_AS_STATIC
)

set_target_properties(
  libopencc
  PROPERTIES
    LINKER_LANGUAGE
      CXX
    OUTPUT_NAME
      opencc
    VERSION
      1.1.1
    SOVERSION
      1.1
)

# Installation

install(
  TARGETS libopencc
  LIBRARY DESTINATION ${DIR_LIBRARY}
  ARCHIVE DESTINATION ${DIR_LIBRARY}
  RUNTIME DESTINATION bin
)

install(
  FILES ${LIBOPENCC_HEADERS}
  DESTINATION ${DIR_INCLUDE}/opencc
)

# Gtest

if (ENABLE_GTEST)
  if (WIN32)
    add_custom_target(
        copy_gtest_to_src
        ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gtest> ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Copy gtest"
    )
    add_custom_target(
        copy_gtest_main_to_src
        ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gtest_main> ${CMAKE_CURRENT_BINARY_DIR}
      COMMENT "Copy gtest_main"
    )
  endif()

  foreach(TESTCASE ${UNITTESTS})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} gtest gtest_main libopencc)
    add_test(${TESTCASE} ${TESTCASE})
    if (WIN32)
      add_dependencies(${TESTCASE} copy_gtest_to_src copy_gtest_main_to_src)
    endif()
  endforeach()
endif()

# Benchmark

if (ENABLE_BENCHMARK)
  add_subdirectory(benchmark)
endif()

# Subdir

add_subdirectory(tools)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,19 @@
 endforeach (CONFIG_TEST_FILE)
 
 if (ENABLE_GTEST)
+  if (WIN32)
+    add_custom_target(
+        copy_gtest_to_test
+        ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gtest> ${CMAKE_CURRENT_BINARY_DIR}
+      COMMENT "Copy gtest"
+    )
+    add_custom_target(
+        copy_gtest_main_to_test
+        ${CMAKE_COMMAND} -E copy $<TARGET_FILE:gtest_main> ${CMAKE_CURRENT_BINARY_DIR}
+      COMMENT "Copy gtest_main"
+    )
+  endif()
+
   include_directories(../deps/gtest-1.7.0/include)
   set(UNITTESTS
     CommandLineConvertTest
@@ -22,5 +35,8 @@
     add_executable(${UNITTEST} ${UNITTEST}.cpp)
     target_link_libraries(${UNITTEST} gtest gtest_main libopencc)
     add_test(${UNITTEST} ${UNITTEST})
+    if (WIN32)
+      add_dependencies(${UNITTEST} copy_gtest_to_test copy_gtest_main_to_test)
+    endif()
   endforeach(UNITTEST)
 endif()

=== src/benchmark/CMakeLists.txt ===
include_directories(..)

add_executable(performance Performance.cpp)
target_link_libraries(performance benchmark libopencc)
add_test(BenchmarkTest performance)

if (WIN32)
  add_custom_target(
    copy_benchmark
    ${CMAKE_COMMAND} -E copy $<TARGET_FILE:benchmark> ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Copy benchmark"
  )
  add_custom_target(
    copy_opencc
    ${CMAKE_COMMAND} -E copy $<TARGET_FILE:libopencc> ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Copy opencc"
  )
  add_dependencies(performance copy_benchmark copy_opencc)
endif()

=== debian/changelog ===
opencc (1.1.1+git20200624+ds2-10) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Backport patch to fix performance regression again.
    Add
    + 0006-Fix-a-bug-in-the-calculation-of-DictGroup-keyMaxLeng.patch
    + 0007-Fix-a-severe-performance-bug-in-Conversion-Convert-t.patch

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 07 Mar 2021 14:20:40 +0800

opencc (1.1.1+git20200624+ds2-9) experimental; urgency=medium

  * Team upload.
  * Remove unused command from autopkgtest scripts
  * Add build-essential to autopkgtest

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 07 Mar 2021 00:54:22 +0800

opencc (1.1.1+git20200624+ds2-8) experimental; urgency=medium

  * Team upload.
  * Enable test when building
  * Add autopkgtest

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 06 Mar 2021 17:57:00 +0800

opencc (1.1.1+git20200624+ds2-7) unstable; urgency=high

  * Team upload.
  * Drop debian/patches/0005 for now due to regression reported.
    See also https://github.com/fcitx/fcitx5/issues/238 .

 -- Boyuan Yang <byang@debian.org>  Fri, 05 Mar 2021 09:37:48 -0500

opencc (1.1.1+git20200624+ds2-6) unstable; urgency=high

  * Team upload.
  * debian/patches/0005: Add upstream patch to fix severe performance
    regression in `Conversion::Convert` that caused O(N^2) complexity.
  * debian/rules: Disable parallel build to workaround some random
    build error for now.

 -- Boyuan Yang <byang@debian.org>  Sun, 28 Feb 2021 19:48:01 -0500

opencc (1.1.1+git20200624+ds2-5) unstable; urgency=medium

  * Team upload.
  * debian/rules: Rewrite to support <!nodoc> build profile.
  * debian/rules: Enable dh_doxygen when building docs.
  * Drop unnecessary build dependencies. (Closes: #981606)
  * debian/control: Mark build-dependency doxygen as <!nodoc>.
  * debian/control: Drop build-dependency on libjs-jquery. Let
    doxygen handle it.
  * debian/control: Drop build-dependency on graphviz. Doxyfile
    did not enable HAVE_DOT.
  * debian/control: Drop build-dependency on dartz. Currently opencc
    uses its vendored copy.

 -- Boyuan Yang <byang@debian.org>  Tue, 02 Feb 2021 11:58:39 -0500

opencc (1.1.1+git20200624+ds2-4) unstable; urgency=medium

  * Build-depends on pkg-kde-tools to handle symbols.
  * debian/libopencc1.1.symbols: Refresh symbols using Debian
    buildd logs.

 -- Boyuan Yang <byang@debian.org>  Sun, 17 Jan 2021 17:52:00 -0500

opencc (1.1.1+git20200624+ds2-3) unstable; urgency=medium

  * Team upload.

  [ Gunnar Hjalmarsson ]
  * Replace shlibs file with symbols file
  * debian/patches/no-remote-images-when-reading-docs-on-disk.patch:
    - Fixes a privacy breach previously reported as Lintian warnings
  * Bump Standards-Version to 4.5.1
  * debian/source/lintian-overrides:
    - Explain why libopencc1.1 is not multi-archified even if
      libopencc-dev depends on it.

  [ Boyuan Yang ]
  * Mark package libopencc-dev as Multi-Arch: same

 -- Boyuan Yang <byang@debian.org>  Sat, 16 Jan 2021 10:36:38 -0500

opencc (1.1.1+git20200624+ds2-2) unstable; urgency=high

  * Team upload.
  * debian/control: Mark package libopencc-data Breaks+Replaces the
    old libopencc2-data package. (Closes: #963187)

 -- Boyuan Yang <byang@debian.org>  Sat, 04 Jul 2020 13:46:28 -0400

opencc (1.1.1+git20200624+ds2-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sat, 04 Jul 2020 06:28:22 -0400

opencc (1.1.1+git20200624+ds2-1~exp2) experimental; urgency=medium

  * Team upload.
  * Rebuild against marisa 0.2.6.

 -- Boyuan Yang <byang@debian.org>  Fri, 03 Jul 2020 17:40:16 -0400

opencc (1.1.1+git20200624+ds2-1~exp1) experimental; urgency=medium

  * Team upload.

  [ 肖盛文 ]
  * add libopencc-doc.doc-base,to register opencc to doc-base
  * d/control:
     - add Section: doc for libopencc-doc
     - add Depends: libjs-jquery for the libopencc-doc package

  [ Boyuan Yang ]
  * Import new upstream snapshot 2020-06-24 to fix some bugs.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Thu, 25 Jun 2020 20:34:50 -0400

opencc (1.1.1+ds1-1~exp1) experimental; urgency=medium

  * Team upload.

  [ 肖盛文 ]
  * New upstream version 1.1.1
  * change libopencc data pkgname from libopencc[num]-data to libopencc-data
  * change libopencc pkgname from libopencc2 to libopencc1.1
  * update debian/libopencc1.1.install for filename *.ocd2
  * d/rules:
     - delete override_dh_missing:
     - use execute_after_dh_auto_clean:
     - use execute_after_dh_auto_install:
  * d/copyright:
     - update dirname for new upstream version
     - add xiao sheng wen <atzlinux@sina.com> for debian/*
     - add Upstream-Contact
  * d/control:
     - add Rules-Requires-Root: no
     - add New Uploaders: xiao sheng wen
     - delete some Replaces: and Breaks:,
       let the new version packages can co-exist with the old ones.
  * add debian/upstream/metadata
  * d/watch: use @PACKAGE@ @ANY_VERSION@@ARCHIVE_EXT@

  [ Boyuan Yang ]
  * ds: Do not include bundled gtest and libmarisa.
  * debian/rules: Explicitly disable building bundled libmarisa.
  * debian/libopencc1.1.shlibs: Reset version requirement.
  * debian/control: Add new build-dependency libmarisa-dev.
  * debian/patches: Refreshed.

 -- Boyuan Yang <byang@debian.org>  Sat, 23 May 2020 15:51:01 -0400

opencc (1.0.6-2) unstable; urgency=medium

  * Team upload.
  * debian/libopencc2.shlibs: Bump version requirement to 1.0.6.
  * debian/control: Bump debhelper compat to v13.
  * debian/rules: Drop as-needed linker flag.

 -- Boyuan Yang <byang@debian.org>  Sat, 02 May 2020 10:46:44 -0400

opencc (1.0.6-1) unstable; urgency=medium

  * Team upload.
  * New upstream release 1.0.6.
  * debian/control:
    + Bump Standards-Version to 4.5.0.
    + Add Debian Chinese Team into uploaders to show team's interest
      in package co-maintenance.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Mon, 13 Apr 2020 18:20:20 -0400

=== debian/control ===
Source: opencc
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Debian Chinese Team <chinese-developers@lists.alioth.debian.org>,
 Asias He <asias@debian.org>,
 YunQiang Su <syq@debian.org>,
 Osamu Aoki <osamu@debian.org>,
 Aron Xu <aron@debian.org>,
 xiao sheng wen <atzlinux@sina.com>,
Build-Depends:
 cmake,
 darts,
 debhelper-compat (= 13),
 doxygen <!nodoc>,
 googletest <!nocheck>,
 libmarisa-dev,
 libtclap-dev,
 python3:any,
 pkg-kde-tools,
 rapidjson-dev,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Section: libs
Homepage: https://github.com/BYVoid/OpenCC
Vcs-Git: https://salsa.debian.org/debian/opencc.git
Vcs-Browser: https://salsa.debian.org/debian/opencc

Package: libopencc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libopencc1.1 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 libopencc-doc,
Description: simplified-traditional Chinese conversion library - development
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the development support files.

Package: libopencc1.1
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libopencc-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: simplified-traditional Chinese conversion library - runtime
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the shared library.

Package: libopencc-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks: libopencc2-data (<< 1.1.1~)
Replaces: libopencc2-data (<< 1.1.1~)
Description: simplified-traditional Chinese conversion library - data files
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the data files.

Package: libopencc-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Description: simplified-traditional Chinese conversion library - document
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the library document files.

Package: opencc
Section: utils
Architecture: any
Multi-Arch: foreign
Depends:
 libopencc1.1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libopencc-doc,
Description: simplified-traditional Chinese conversion tool
 opencc is a library for converting character between traditional Chinese and
 simplified Chinese.
 .
 This package includes the conversion tool.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

# Disable parallel build to circumvent some random build error
# (needs further investigation)
%:
	dh $@ --buildsystem=cmake --with pkgkde_symbolshelper --no-parallel

BUILD_OPTIONS = \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/ \
    -DCMAKE_BUILD_TYPE=Release \
    -DBUILD_BUNDLED_LIBMARISA=OFF

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
BUILD_OPTIONS += -DBUILD_DOCUMENTATION=ON
else
BUILD_OPTIONS += -DBUILD_DOCUMENTATION=OFF
endif

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_OPTIONS += -DENABLE_GTEST=ON
else
BUILD_OPTIONS += -DENABLE_GTEST=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

execute_after_dh_auto_clean:
	find . -name *.pyc -delete

execute_after_dh_installdocs-indep:
ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	dh_doxygen --indep
endif

override_dh_installdocs:
	dh_installdocs -plibopencc-doc --doc-main-package=opencc
	dh_installdocs --remaining-packages

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS.md

=== debian/watch ===
version=4
opts="dversionmangle=s/\+ds\d?$//,repack,repacksuffix=+ds1,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/byvoid/@PACKAGE@/releases \
 (?:.*?/)?(?:ver\.)?@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
